


Q&AKey
More Macro-keys for Q&A

USER REFERENCE GUIDE

















































Copyright (c) 1991, 1992 by Michael H. Shacter
7825 Marion Lane
Bethesda, Maryland 20814
                                                                Version 1.1






                                  Q&AKEY
                           USER REFERENCE GUIDE

          


     Q&AKey (More Macro-keys for Q&A) is a memory resident utility (TSR)
that adds 90 new keys to the number of keys recognized by Q&A for the
purpose of running single keystroke macros.  To avoid conflicts with other
TSRs, Q&AKey does not rely on the traditional shift keys (Shift/Alt/Ctrl).
Instead, Q&AKey uses CapsLock as an auxiliary shift key.  Veteran PC users
should feel at home with the choice of CapsLock, since, on an enhanced
keyboard, it is located in the same position that the Ctrl key used to
occupy.  Q&AKey works with Q&A 4.0 only.  Q&AKey uses a mere 560 bytes of
RAM, can be unloaded from memory, and does not interfere with the normal
operation of CapsLock.

     Q&AKey is user supported software.  If you are using Q&AKey, I need
you to register your copy.  Information regarding registration may be found
at the end of this document.

     Q&A has a native capability for creating single keystroke macros
through the assignment of a macro "key identifier", such as a Ctrl- or
Alt-key combination.  Nonetheless, you will find that the 90 new macro keys
offered by Q&AKey provide additional flexibility for customizing Q&A.  For
example, the number of key identifiers is limited because many eligible
keys are already used by Q&A.  It is also useful to reserve the key
identifiers for nesting macros.


                    Defining and Running QA-key Macros

     Macros created with Q&AKey are called QA-keys.  In general, QA-keys
operate in an analogous manner to Alt-key and Ctrl-key macros.  To run a
QA-key macro simply hold down CapsLock and press a key.  Q&AKey will then
tell Q&A to run a macro with the name "QA-" plus the corresponding key
name.  Thus, holding down CapsLock and pressing P will cause Q&A to run the
macro with the name QA-P, just as holding down Alt and P will run <altp>.

     Before you can run a QA-key macro, you must first define it.  To
facilitate macro definition, Q&AKey has a Quick Define feature.  To use
Quick Define, hold down the Shift key and the CapsLock key simultaneously
then press the key you wish to define.  This will automatically initiate
the macro define sequence as if you had pressed the following keys:

     1.  Shift F2 (Display the Macro Menu).

     2.  D (Define Macro)

     3.  Enter (Do not assign a key identifier.  Although QA-keys operate
in a similar manner to macros with key identifiers, they are really named
macros.)

The "Macro Define" menu may appear momentarily on your screen, then you
will see the flashing square in the bottom right corner indicating the
macro recorder is on.

     Now record your macro as you ordinarily would.  When you have finished
recording, press Shift F2 and Q&AKey will automatically fill in the name of
your macro.  At this point you may back up and add an optional description
after the name of the macro.  Complete macro definition by making elections
with respect to "Show screen" and "End with menu", then press F10 to
finish.

     For example, to Quick Define QA-F12, hold down Shift and CapsLock
together, then press F12.  Now record keystrokes as you ordinarily would.
Press Shift F2 when you have finished recording.  Q&AKey will automatically
name your new macro QA-F12.  Finish recording in the conventional manner by
making elections with respect to "Show screen" and "End with menu", then
press F10.

     Please read the section entitled "Compatibility and Keyboard
Peculiarities", if you encounter any difficulties with the Quick Define
feature.

     You may also define a QA-key macro in a more conventional manner, as
follows:

     1.  Press Shift F2 to display the Macro Menu.

     2.  Press D (Define Macro)

     3.  Press Enter in response to the message at the bottom of the screen
asking you to assign a key identifier.  (Although QA-keys operate in a
similar manner to macros with key identifiers, they are really named
macros.)

     4.  Record your macro.

     5.  When you have finished recording, press Shift F2 to display the
"Macro Options" menu.  The first choice on this menu is "Macro Name".  Now
press the QA-key (CapsLock + key) you wish to assign to your macro and
Q&AKey will fill in the name for you. 

     6.  Finish macro definition by making elections with respect to "Show
screen" and "End with menu", then press F10.

Notice that, with the exception of Step 5, these are the same steps you
would take to define any macro.

     You should be aware that in one small respect QA-keys are not as
capable as native Q&A key identifier macros.  The CapsLock key must be
released before running another QA-key.  In contrast, you may hold down the
Alt-key and press a key several times in order to run a series of macros or
one macro several times.  Most users will not find this a serious
inconvenience.

     Q&AKey does not interfere with the normal operation of CapsLock, and
with each use of a QA-key, CapsLock is restored to its prior state.  Thus
if CapsLock was off when you pressed the QA-key, it will stay off; if it
was on, it will stay on.


                              Naming QA-keys

     Unlike native Q&A key identifiers, QA-keys can be assigned to almost
any key.  Accordingly, space (QA-SP), insert (QA-IN), left (QA-LE), and
cursor pad left (QA-XLE), are all perfectly acceptable QA-keys.  (The only
exceptions are the obvious ones, shift keys, Num and Scroll Lock, Print
Screen and Pause.)  This will add 90 new keys to an enhanced keyboard; 75
keys to a PC keyboard.  Notice that on an enhanced keyboard, Q&AKey
distinguishes between the cursor keys on the numeric keypad and those on
the cursor keypad.  Moreover, Q&AKey will recognize F11 and F12.

     Q&AKey uses abbreviations for certain of the non-alphanumeric keys.  A
list of these abbreviations is included as an Appendix to this document.


                         Renaming Existing Macros

     Existing macros may be converted to QA-key macros by editing the ASCII
file containing the macros.  The easiest way to demonstrate the procedure
for renaming macros is by comparison of two macros, before and after
editing.

A macro with the key identifier Ctrl-F will begin as follows:

     <begdef><ctrlf><name>"<caps,>ctrlf<caps.>" . . .
 key identifier^           ^....macro name...^

The same macro renamed as QA-F begins as follows:

     <begdef><nokey><name>"QA-F" . . .
no key identifier^           ^QA-key name

A macro with no key identifier named "Header" would begin like this:

     <begdef><nokey><name>"HEADER" . . .
no key identifier^           ^macro name

The same macro renamed as QA-H begins as follows:

     <begdef><nokey><name>"QA-H" . . .
no key identifier^          ^QA-key name

Notice that macro names and QA-key names are enclosed in quotation marks.
For a complete list of possible QA-key macro names, please see the
Appendix.


                       Loading and Unloading Q&AKey

     Q&AKey must be loaded into memory before you run Q&A.  To load Q&AKey
into memory type "Q&AKey" at the command line.  If Q&AKey is not on your
path or in the default directory, you must include the full path name.
Q&AKey then becomes memory resident for use in conjunction with Q&A.
Q&AKey will refuse to load a second copy of itself, if it determines that
it has previously been loaded into memory.

     If Q&AKey detects that you are using an enhanced keyboard when it is
first loaded into memory, it will display the additional sign on message
"Enhanced keyboard support".  This means that Q&AKey will (i) recognize the
F11 and F12 function keys, (ii) distinguish between the cursor movement
keys on the numeric keypad and those on the cursor pad, allowing you to
assign different macros to each, and (iii) recognize the special keys on
the numeric keypad such as Numeric Enter and Numeric 5.

     To unload Q&AKey from memory type "Q&AKey /U".  If you have loaded any
TSRs after Q&AKey, be sure to unload them first.  Since Q&AKey utilizes
such a small amount of memory, you may not wish to go to the trouble of
unloading it.  It should not interfere with the operation other programs.

     The most practical way to load and unload Q&AKey is with a batch file
that also starts Q&A.  A simple batch file would look like this:

         Q&AKey
         QA
         Q&AKey /U

     Similarly, if you start Q&A from your AUTOEXEC.BAT file, you should
edit the lines immediately before and after the line that starts Q&A in
accordance with the preceding instructions.  A simple AUTOEXEC.BAT file
might look like this:

         PROMPT $p$g
         PATH C:\DOS;C:\QA;C:\UTILITY
         Q&AKey
         QA
         Q&AKey /U

Of course, you will add full path names if Q&AKey is not on your path.
Incidentally, Q&AKey releases its copy of the environment, so it does not
matter where in your batch file you place commands that go into the
environment.

     On a 386SX, 386DX or 486 computer with an appropriate memory manager,
such as QEMM, DR DOS's MemoryMAX, or MS-DOS 5.0's HIMEM.SYS and EMM386.EXE,
Q&AKey may also be loaded high using the appropriate LOADHI command.  If
you run Q&A in DESQview, you must load Q&AKey after loading DESQview.
Typically, this would be through a batch file that also loads Q&A.


                                  Quirks

     Since Q&AKey utilizes Q&A's capability for naming macros, it is also
subject to the traits associated with this feature.  If a QA-key is pressed
before any macros have been defined, or when no macro file is then loaded
in memory, the name of the QA-key will be treated as typed text.  The
effect will depend on where you are in Q&A.  If you are in "Write", at the
"Type/Edit" screen, the letters of the name will be inserted in the active
document as text.  Alternatively, if a menu is active, the keys will be
discarded unless one of the keys in the QA-key name happens to correspond
with the letters of one of the menu choices, in which case the menu choice
will be selected.

     If there are active macros and you press a QA-key that has not been
defined, Q&A will run the first macro that most closely matches the name of
the QA-key  you pressed.  This will frequently be the top macro name on the
macro list.

     Finally, QA-keys cannot be nested.  Thus, pressing a QA-key while
defining a macro will have no effect.


                 Compatibility and Keyboard Peculiarities

     Q&AKey has been tested on IBM-compatible systems under DR DOS 6.0 (the
better DOS), MS-DOS versions 3.x and 5.0, QEMM 6.0 (with Stealth type M
enabled), and DESQview, version 2.4 (within a DESQview window).  If Q&AKey
does not operate as described, the most likely explanation is a TSR
conflict.  Q&AKey should be compatible with other TSRs because it uses a
different hot key arrangement and because it does not trap interrupt 9.  My
experience has verified this, although it is impossible for me to have
tested it with all TSRs.  Please let me know if you encounter any
difficulties.

     The standard advice when confronted with TSR conflicts is first to
unload all TSRs, then load Q&AKey to determine if it works by itself.  If
so, the problem is a TSR conflict.  To try and isolate the offender,
re-load the other TSRs one at a time.  The other advice for remedying TSR
conflicts is to try changing the order in which the programs are loaded.
Since Q&AKey only works with Q&A, it makes sense to load it immediately
before loading Q&A so it can be unloaded immediately after you exit Q&A.
But Q&AKey really does not care where it is loaded, so long as it is loaded
before Q&A.

     Another type of compatibility problem may arise with certain
keyboards.  Most programs that manipulate the keyboard warn about the Tandy
keyboard.  Not having access to a Tandy keyboard, I cannot verify whether
there is an incompatibility with Q&AKey.

     I am aware of one incompatibility that may arise when using the Quick
Define feature.  My Northgate keyboard does not recognize certain
keystrokes when more than one than shift key is held down simultaneously.
For example, it recognizes CapsLock-Shift-T and CapsLock-Shift-I, but not
CapsLock-Shift-Y or CapsLock-Shift-U.  (Incidentally, this anomaly is not
unique to CapsLock, but also occurs with other shift key pairs.)  If you
encounter this problem, use the alternative method for defining QA-keys
described above.  This problem is a failing of the keyboard and cannot be
remedied by Q&AKey or any other program.

     Q&AKey always restores CapsLock to the same state it was before you
hit a QA-key, but in certain circumstances you might believe Q&AKey had
erred.  If you have a PC keyboard with a CapsLock light, the light may
change even though CapsLock is set correctly.  (This idiosyncrasy does not
generally occur with enhanced keyboards.)  If you check the "Cap" on the
Q&A status line, however, you can verify the correct state of CapsLock.  If
CapsLock is on "Cap" will appear on the status line.  Notwithstanding these
oddities and indications to the contrary, it bears repeating that Q&AKey
will always reset CapsLock to the state it was found.

     If you use a memory map utility to determine how Q&AKey is loaded into
memory, do not be concerned to find that Q&AKey is listed as unknown.  This
happens because Q&AKey, like a good citizen, releases its copy of the
environment.


                               Program Notes

     Q&AKey is written entirely in assembly language.  It is based in part
on my program MALT (More Alt-keys for the Perfects), which provides a
similar macro capability for WordPerfect and other members of the WPCorp
family.

     I drew on a number of reference sources detailing the operation of the
keyboard and the ROM BIOS in connection with the preparation of Q&AKey and
MALT.  Of these, by far the most instructive was the article by Michael J.
Mefford entitled "An In-depth Exploration of the PC Keyboard and its
Interrupt Service Routines", which appeared in the May 1990 issue of
Microsoft Systems Journal (Volume 5, Number 3).  His method for detecting
the presence of an enhanced keyboard is incorporated in Q&Key.  Also very
useful were the pair of articles by Barry Simon (someone for whom I have a
deep admiration because of his work on CTRLALT and STACKEY) entitled
"Learning Your Way Around the Keyboard under DOS", which appeared in the
December 25, 1990 and January 15, 1991 issues of PC Magazine (Volume 9,
Number 22 and Volume 10, Number 1).  His program BIOSDATA, which was
distributed with the articles, was especially helpful in deciphering the
operation of the PC keyboard BIOS.

     Two other informative resources were DOS Programmer's Reference (2nd
Edition), by Terry Dettmann and Jim Kyle, and The New Peter Norton
Programmer's Guide to the IBM PC & PS/2, by Peter Norton and Richard
Wilton.  I also referred frequently to Advanced MS-DOS Programming (Second
Edition), by Ray Duncan, but not for keyboard information.

     Surprisingly, only the Norton book contained even a partial list of
the codes generated by the ROM BIOS for legal keys on the enhanced
keyboard.  To remedy this deficiency, I have prepared a program called
SCANASC for use by the programming community (or anyone else who happens to
be curious).  SCANASC reports the scan and ASCII codes for all keys
interpreted by the BIOS keyboard services in hex and decimal and identifies
whether the key is available only on the enhanced keyboard.  SCANASC will
optionally prepare a customized list of the values for all keys pressed
during a session for later reference.  There is no charge for the program
and it is available in the Programming Forum of PCMagnet where it is called
SCANAS.ZIP.  (Notice the absence of the final "C" in the root name.
CompuServe only permits six-letter root names.)


                           Standard Disclaimers

     By now all personal computer users should realize that there are no
warranties attached to software, except for disk errors and performance in
accordance with specifications.  This software is no different from any
other in that respect.  Accordingly, there are no warranties of
merchantability or fitness for a particular purpose, nor will the author be
responsible for any damages (incidental, consequential, or otherwise) in
excess of the purchase price.  Q&AKey has been thoroughly tested by me,
and, I believe, they will work as described.  If you encounter problems,
please let me know.  I may be reached at the address given below or on
CompuServe (ID No. 76170,1627).


                      Registration/License/Copyright

     Q&AKey is a user supported program.  It is not public domain.  If you
are using Q&AKey for personal use, you should pay a $15 registration fee.
Q&AKey has deliberately been priced low to encourage registration.  Q&AKey
may not be used in business without a license.  For information about
securing a license to use Q&AKey in business, please see the section
entitled "Business Use".


                              How to Register

     To register Q&AKey for personal use, please send your $15 check or
money order to:

         Michael H. Shacter
         7825 Marion Lane
         Bethesda, Maryland 20814-1337

     In exchange, you will receive an acknowledgement and at least $15
worth of satisfaction.  For your convenience a registration form is
enclosed.  Please note that you will not be sent a disk, only a
registration number.  If you absolutely must have a copy of Q&AKey on disk,
please send an additional $10.  Please (a) specify 5 or 3 disk size, (b)
include 5% sales tax if you are a Maryland resident, and (c) be prepared to
wait 2 to 3 weeks.


                               Business Use

     A license is required to use Q&AKey in business, after a reasonable
trial period.  Business use includes use by governmental entities,
non-profit organizations, and any other use that is not strictly personal.
You may obtain a license by writing to me at the above address.  The
license fee will depend on the number of Q&AKey users in your business.
Discounts are available for multiple copies.  Please feel free to submit a
reasonable proposal, including any special requirements for customization
you may have.  Remember, if you are using Q&AKey to make money, I am too,
and in this respect, my expectation of a living is superior to yours.


                            Other restrictions

     All authorized users are granted a limited license to make copies of
Q&AKey without charge, subject to the restrictions contained elsewhere in
this document as well these:

          (a) Q&AKey must be distributed in absolutely unmodified form,
including Q&AKey, the registration form and this documentation.

          (b) For-profit use of Q&AKey without a license is prohibited.

          (c) Q&AKey may not be included or bundled with any other product
for any reason.
 
     Not-for-profit user's groups, such as the Capital PC User Group, are
permitted to charge a small fee for materials, handling, postage, and
general overhead.  No other organization is permitted to charge for
distribution of copies of Q&AKey.

     Electronic bulletin board system operators are encouraged to post
Q&AKey on their bulletin board systems for downloading by their users, if
the above conditions are met, and if no special fee is necessary to access
the Q&AKey files (a general fee to access the BBS is acceptable).
Likewise, all authorized users are encouraged to upload to Q&AKey to BBS
meeting these requirements.


                                 APPENDIX

                           Naming QA-key Macros


     Q&AKey uses a set of abbreviations to identify certain non-
alphanumeric QA-keys.  This appendix describes the Q&AKey naming
strategy.  The abbreviations, while logical, are necessarily terse because
of the need for Q&AKey to conserve memory (longer names mean increased
memory requirements).

     Alphanumeric QA-key macros simply consist of the prefix "QA-" followed
by the number or letter.  Thus, CapsLock + P is associated with the macro
named QA-P and CapsLock + 4 is associated with the macro QA-4.  Punctuation
keys are generally handled in the same fashion, except that Q&A will not
permit the characters "/" and "," to form part of a macro name.  These two
keys are abbreviated as "SL" and "CO", respectively.  In general, cursor
positioning keys and function keys use a two letter abbreviation following
the prefix "QA-".  For example, CapsLock + F1 is associated with the macro
named QA-F1.  To distinguish between keys on the numeric keypad and
identically named keys on the cursor pad of the enhanced keyboard, Q&AKey
adds an "X" in the latter case between the prefix "QA-" and the key name.
Accordingly, the macro associated with CapsLock + PgDn on the numeric
keypad is QA-PD while CapsLock + Cursor Pad PgDn on the enhanced keyboard
is QA-XPD.

     The following table lists all non-alphanumeric QA-keys and their
associated macro names.  Keys preceded by an asterisk are available only on
enhanced keyboards.  The prefix CP signifies a key on the enhanced
keyboard's cursor pad.




           ESC            QA-ES           \              QA-\
           -              QA--            ,              QA-CO
           =              QA-=            .              QA-.
           Backspace      QA-BS           /              QA-SL
           Tab            QA-TB           *Num /         QA-NSL
           [              QA-[            Num *          QA-N*
           ]              QA-]            Space          QA-SP
           Enter          QA-CR           F1             QA-F1
           *Num Enter     QA-NCR          F2             QA-F2
           '              QA-'            F3             QA-F3
           `              QA-~            F4             QA-F4
           F5             QA-F5           Right          QA-RT
           F6             QA-F6           Left           QA-LE
           F7             QA-F7           Num -          QA-N-
           F8             QA-F8           Num +          QA-N+
           F9             QA-F9           *Num 5         QA-N5
           F10            QA-F0           *CP Insert     QA-XIN
           *F11           QA-F11          *CP Delete     QA-XDE
           *F12           QA-F12          *CP Home       QA-XHO
           Insert         QA-IN           *CP End        QA-XED
           Delete         QA-DE           *CP PageUp     QA-XPU
           Home           QA-HO           *CP PageDown   QA-XPD
           End            QA-ED           *CP Up         QA-XUP
           PageUp         QA-PU           *CP Down       QA-XDO
           PageDown       QA-PD           *CP Right      QA-XRT
           Up             QA-UP           *CP Left       QA-XLE
           Down           QA-DO


